(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: vector_types_spec.mli,v 1.4 2013-07-25 11:53:45 fclement Exp $ *)

module type DIMENSION =
sig
  val get_dim : unit -> Unatural.t;;
end
;;

module type VECTOR_TYPES =
sig
  type 'a t = private 'a array;;
  
  val to_vector : 'a array -> 'a t;;
  external of_vector : 'a t -> 'a array = "%identity";;
end
;;

module type VECTOR_TYPES_MAKER =
  functor (D : DIMENSION) ->
  VECTOR_TYPES
;;
