(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uarray2_with_c_layout.ml,v 1.11 2014/01/10 15:28:04 fclement Exp $ *)

(* More operations on two-dimensional bigarrays with C layout. *)

open Bigarray;;

let dim1 = Array2.dim1
and dim2 = Array2.dim2
and get = Array2.get
;;

(* Iterators. *)

let iter f a =
  let ni = dim1 a in
  let nj = dim2 a in
  for i = 0 to ni - 1 do
    for j = 0 to nj - 1 do
      f (get a i j)
    done;
  done;;

let iterij f a =
  let ni = dim1 a in
  let nj = dim2 a in
  for i = 0 to ni - 1 do
    for j = 0 to nj - 1 do
      f i j (get a i j)
    done;
  done;;
